<template>
  <div class="video-content-container">
    <div class="text-content">
      <pre>{{ settings.text }}</pre>
    </div>
    <div class="video-content" ref="videoContainer">
      <img
        @click="videoImageClicked()"
        v-if="!showVideo"
        :src="settings.image"
        class="video-img"
        :class="{ 'without-link': !settings.link }"
        :style="settings.style"
      />
      <div v-else class="holder" ref="holder">
        <youtube
          class="youtube-video"
          :video-id="settings.videoId"
          :player-width="videoWidth"
          :player-height="videoHeight"
          @ready="ready"
        ></youtube>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    settings: {
      type: Object,
    },
  },
  data() {
    return {
      scrollInterval: null,
      showVideo: false,
      scrollInterval: null,
      videoWidth: 300,
      videoHeight: 200
    };
  },
  mounted() {
    var holder = this.$refs["holder"];
    if (!holder) return;
    this.scrollInterval = setInterval(() => {
      if (window.scrollY >= holder.offsetTop + holder.clientHeight) {
        if (this.player) this.player.pauseVideo();
      }
    }, 150);
  },
  beforeDestroy() {
    if (this.scrollInterval) clearInterval(this.scrollInterval);
  },
  methods: {
    ready(event) {
      this.player = event.target;
      this.player.playVideo();
    },
    videoClicked() {
      if (this.player) {
        var playerState = this.player.getPlayerState();
        if (playerState == 1) this.player.pauseVideo();
        else this.player.playVideo();
      }
    },
    videoImageClicked() {
      var parent = this.$refs["videoContainer"];
      var parentWidth = parent.clientWidth;
      var parentHeight = parent.clientHeight;
      this.videoWidth = parentWidth;
      this.videoHeight = parentHeight;
      console.log(this.videoWidth, this.videoHeight)
      this.showVideo = true;
    },
  },
};
</script>

<style lang="scss" scoped>
.video-content-container {
  display: flex;
  justify-content: space-between;
  width: 100%;

  .text-content {
    max-width: 41.125rem;

    pre {
      color: $thor-default-font-color;
      font-family: "Roboto";
      font-weight: 500;
      font-style: normal;
      font-size: 1.5rem;
      white-space: pre-line;
    }
  }

  .video-content {
    max-width: 32rem;

    img {
      max-width: 32rem;
    }
  }

  .video-img {
    cursor: pointer;
  }

  .youtube-video {
    width: 100%;
  }

  .holder {
    position: relative;
  }

  .overlay {
    width: 100%;
    height: 70%;
    position: absolute;
    color: white;
    opacity: 50%;
    pointer-events: none;
    z-index: 100;
  }
}
</style>